#include <iostream>

import Garden;

int main() {
	// Garden<Carot> gCarot; // Compilation error because 'Carot' hasn't been exported...
	Garden<Salad> gSalad; // Any kind of 'Salad' in the garden...
	Salad s;
	gSalad.plant(s);
	Garden<Batavia> gBatavia; // Only batavias...
	Batavia b;
	gBatavia.plant(b);

	// Compilation error because 'Garden<Salad>' and 'Garden<Batavia>' *ARE NOT* related to each other:
	// std::cout << std::boolalpha << gSalad.is_bigger_than_V1(gBatavia);
	 // No compilation error because 'Batavia' inherits from 'Salad':
	std::cout << std::boolalpha << "'gSalad' size > 'gBatavia' size: " << gSalad.is_bigger_than_V2(gBatavia) << std::endl;
	// std::cout << std::boolalpha << gBatavia.is_bigger_than_V2(gSalad); // Unfortunately, (expected) compilation error...
	// No compilation error because 'Batavia' inherits from 'Salad' || 'Salad' inherits from 'Batavia':
	std::cout << std::boolalpha << "'gBatavia' size > 'gSalad' size: " << gBatavia.is_bigger_than_V3(gSalad) << std::endl;

	gSalad = Garden<Salad>(); // Move assignment
	std::cout << std::boolalpha << "'gSalad' size: " << gSalad.size() << std::endl; // Display is ''gSalad' size: 0'
	// Compilation error because move assignment deals with 'Garden<Salad>' only:
	// gSalad = Garden<Batavia>();
	gSalad.transfer(gBatavia);
	std::cout << std::boolalpha << "'gSalad' size: " << gSalad.size() << std::endl; // Display is ''gSalad' size: 1'
	// Compilation error sounds nice since we don't want, for instance, lettuces in garden of batavias:
	// gBatavia.transfer(gSalad); 

	return 0;
}
